# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AdminCatalogItemPatch(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'icon_id': 'str',
        'bulk_request_limit': 'int',
        'form_id': 'str'
    }

    attribute_map = {
        'icon_id': 'iconId',
        'bulk_request_limit': 'bulkRequestLimit',
        'form_id': 'formId'
    }

    def __init__(self, icon_id=None, bulk_request_limit=None, form_id=None):  # noqa: E501
        """AdminCatalogItemPatch - a model defined in Swagger"""  # noqa: E501
        self._icon_id = None
        self._bulk_request_limit = None
        self._form_id = None
        self.discriminator = None
        if icon_id is not None:
            self.icon_id = icon_id
        if bulk_request_limit is not None:
            self.bulk_request_limit = bulk_request_limit
        if form_id is not None:
            self.form_id = form_id

    @property
    def icon_id(self):
        """Gets the icon_id of this AdminCatalogItemPatch.  # noqa: E501

        icon id  # noqa: E501

        :return: The icon_id of this AdminCatalogItemPatch.  # noqa: E501
        :rtype: str
        """
        return self._icon_id

    @icon_id.setter
    def icon_id(self, icon_id):
        """Sets the icon_id of this AdminCatalogItemPatch.

        icon id  # noqa: E501

        :param icon_id: The icon_id of this AdminCatalogItemPatch.  # noqa: E501
        :type: str
        """

        self._icon_id = icon_id

    @property
    def bulk_request_limit(self):
        """Gets the bulk_request_limit of this AdminCatalogItemPatch.  # noqa: E501

        Max number of instances that can be requested at a time  # noqa: E501

        :return: The bulk_request_limit of this AdminCatalogItemPatch.  # noqa: E501
        :rtype: int
        """
        return self._bulk_request_limit

    @bulk_request_limit.setter
    def bulk_request_limit(self, bulk_request_limit):
        """Sets the bulk_request_limit of this AdminCatalogItemPatch.

        Max number of instances that can be requested at a time  # noqa: E501

        :param bulk_request_limit: The bulk_request_limit of this AdminCatalogItemPatch.  # noqa: E501
        :type: int
        """

        self._bulk_request_limit = bulk_request_limit

    @property
    def form_id(self):
        """Gets the form_id of this AdminCatalogItemPatch.  # noqa: E501

        form id  # noqa: E501

        :return: The form_id of this AdminCatalogItemPatch.  # noqa: E501
        :rtype: str
        """
        return self._form_id

    @form_id.setter
    def form_id(self, form_id):
        """Sets the form_id of this AdminCatalogItemPatch.

        form id  # noqa: E501

        :param form_id: The form_id of this AdminCatalogItemPatch.  # noqa: E501
        :type: str
        """

        self._form_id = form_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AdminCatalogItemPatch, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdminCatalogItemPatch):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
